package com.tzld.piaoquan.ad.engine.service.predict.container;

import com.alibaba.fastjson.JSONObject;
import com.tzld.piaoquan.ad.engine.commons.feign.CommonResponse;
import com.tzld.piaoquan.ad.engine.commons.feign.longvideo.abtest.LongVideoFeign;
import com.tzld.piaoquan.ad.engine.commons.feign.longvideo.abtest.request.AbTestConfigRequest;
import com.tzld.piaoquan.ad.engine.commons.math.Tuple;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.*;

@Component
public class AbTestConfigContainer {
    @Autowired
    LongVideoFeign longVideoFeign;
    @Value("${ad.abtest.time.plan.code:555}")
    String adTestCode;

    //List<Tuple<Integer>>
    Map<String,List<JSONObject>> adTimePlanMap=new HashMap<>();
    @PostConstruct
    public void initContainer(){
        Timer timer = new Timer();

        timer.schedule(new TimerTask() {
            @Override
            public void run() {
                try {
                    initMap(null,"ab_test002");
                }catch (Exception e){
                    e.printStackTrace();
                }
            }
        }, 0, 1000*30);
    }




    public void initMap(Integer appType,String typeValue){
        AbTestConfigRequest request=new  AbTestConfigRequest();
        request.setAppType(0);
        request.setTypeValue(typeValue);
        CommonResponse<JSONObject> response=longVideoFeign.getAbTestConfig(request);
        JSONObject object=response.getData();
        for(Map.Entry<String,Object> entry:object.getInnerMap().entrySet()){
            for(Map<String,Object> map:(List<Map>)entry.getValue()){
                if(adTestCode.equals(map.get("abExpCode").toString())){
                    adTimePlanMap=JSONObject.parseObject(map.get("configValue").toString(),Map.class);
                    break;
                }
            }
        }

    }

    public Boolean containsCode(String code){
        return adTimePlanMap.keySet().contains(code);
    }

    public Boolean inWithoutAdTime(String code,Integer hourOfDay){
        Boolean flag=false;
        for(JSONObject object:adTimePlanMap.getOrDefault(code,new ArrayList<>())){
            if(object.getInteger("x")<=hourOfDay&&hourOfDay<object.getInteger("y")){
                return true;
            }
        }
        return flag;
    }

    public Boolean inAdTimeTest(JSONObject abExpInfo){
        List<Map<String,Object>> mapList=(List)abExpInfo.get("ab_test002");
        for(Map<String,Object> map:mapList){
            if(adTestCode.equals(map.getOrDefault("abExpCode",""))){
                return true;
            }
        }
        return false;
    }



    public static void main(String[] args){
        Map<String, Tuple<Integer>> map =new HashMap<>();
        Tuple<Integer> t=new Tuple<>();
        t.setX(1);
        t.setY(2);
        map.put("sk",t);
        System.out.println(JSONObject.toJSONString(map));
    }
}
