package com.tzld.piaoquan.ad.engine.service.predict.container;

import com.tzld.piaoquan.ad.engine.service.predict.model.threshold.ThresholdPredictModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.HashMap;
import java.util.Map;

@Component
public class ThresholdModelContainer {

    @Autowired
    private ApplicationContext applicationContext;

    public static Map<String,ThresholdPredictModel> modelMap=new HashMap<>();
    @PostConstruct
    public void init() {
        Map<String,ThresholdPredictModel> beanMap= applicationContext.getBeansOfType(ThresholdPredictModel.class);
        beanMap.forEach((s,model)->{
            modelMap.put(model.getName(), model);
        });
    }

    public static ThresholdPredictModel getThresholdPredictModel(String modelName){
        return modelMap.getOrDefault(modelName,getBasicPredictModel());
    }

    public static ThresholdPredictModel getBasicPredictModel(){
        return modelMap.get("basic");
    }
}
